#ifndef CPUBOOT__OMAP_H
#define CPUBOOT__OMAP_H

#include <stdint.h>

#define OMAP_MAX_IMAGE_SIZE (64*1024)
#define BOOT_MSG_PERF_BOOT (0xF0030002)

#define USB_VENDOR_TI (0x451)
#define USB_PRODUCT_TI_OMAP3430 (0xd009)

typedef struct {
	uint8_t id;
	uint8_t length;
	uint8_t fixed;
} __attribute__((__packed__)) omap_asic_id_sub_header;

typedef struct {
	omap_asic_id_sub_header header;
	uint8_t device[3];
	uint8_t version;
} __attribute__((__packed__)) omap_asic_id_id_sub;

typedef struct {
	omap_asic_id_sub_header header;
	uint8_t data;
} __attribute__((__packed__)) omap_asic_id_secure_mode_sub;

typedef struct {
	omap_asic_id_sub_header header;
	uint8_t data[20];
} __attribute__((__packed__)) omap_asic_id_public_id_sub;

typedef struct {
	omap_asic_id_sub_header header;
	uint8_t data[20];
} __attribute__((__packed__)) omap_asic_id_root_key_hash_sub;

typedef struct {
	omap_asic_id_sub_header header;
	uint8_t public_rom_crc[4];
	uint8_t secure_rom_crc[4];
} __attribute__((__packed__)) omap_asic_id_checksum_sub;

typedef struct {
	uint8_t items;
	omap_asic_id_id_sub id;
	omap_asic_id_secure_mode_sub secure_mode;
	omap_asic_id_public_id_sub public_id;
	omap_asic_id_root_key_hash_sub root_key_hash;
	omap_asic_id_checksum_sub checksum;
} __attribute__((__packed__)) omap_asic_id;

#endif /* CPUBOOT__OMAP_H */
